﻿using Nemerle;
using Nemerle.Collections;
using Nemerle.Text;
using Nemerle.Utility;

using System;
using System.Diagnostics;
using System.Reflection;
using System.Collections.Generic;
using System.Linq;

namespace LogGrok.Diagnostics.Environment
{
  public module ComponentProvider
  {
      public DetectCurrentComponent() : string
      {
        def stackTrace = StackTrace(false);
        def stackFrames = stackTrace.GetFrames();
        def companyNamespace = stackFrames
            .Select(o => o.GetMethod().DeclaringType)
            .Where(o => o.Assembly != _diagnosticsAssembly)
            .Where(o => o.Namespace.StartsWith(_companyNamespacePrefix))
            .Select(o => o.Namespace)
            .FirstOrDefault();
        
         companyNamespace ?? _unknownComponent;  
      }
      
      private _diagnosticsAssembly : Assembly = typeof(Logger).Assembly;
      private _companyNamespacePrefix : string = "LogGrok";
      private _unknownComponent : string = "Unknown";
  }
}
