﻿using Nemerle;
using Nemerle.Collections;
using Nemerle.Text;
using Nemerle.Utility;

using System;
using System.IO;
using System.Runtime.InteropServices;
using System.Windows.Interop;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Input;

namespace LogGrok.Infrastructure.Behaviors.DataObjects
{
  public class FileSystemEntriesDataObject
  {
      public this(dataObject : DataObject)
      {
          _dataObject = dataObject;
      }
      
      public GetFilesPath() : IEnumerable.[string]
      { 
        def selectFiles = fileSystemEntry =>
        {            
            if (Directory.Exists(fileSystemEntry))
                Directory.EnumerateFiles(fileSystemEntry, "*", SearchOption.AllDirectories);
            else if (File.Exists(fileSystemEntry))
                [ fileSystemEntry ];
            else
                [ ];
        };
        
        def fileSystemEntries = _dataObject.GetFileDropList().Cast.[string]();
        def files = fileSystemEntries.SelectMany(selectFiles);
        
        files;
      }
      
      private _dataObject : DataObject;
  }
}
