﻿using Nemerle;
using Nemerle.Text;
using Nemerle.Utility;
using Nemerle.Extensions;

using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Media;
using System.Text.RegularExpressions;

namespace LogGrok.LogView
{    
    public enum ColorRuleUsage
    {
        | None
        | Line
        | ParsedAreas
    }

    [Record]
    public class TextColor
    {
        public Foreground : Color { get; set }
        public Background : Color { get; set }
    }    
    
    [Record]
    public class ColorRule
    {        
        public Name        : string         { get; set }
        public Rule        : Regex          { get; set }
        public TextColor   : TextColor      { get; set }
        public SearchAreas : List[string]   { get; set }
        public Usage       : ColorRuleUsage { get; set }
    }
}
