using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text.RegularExpressions;
using System.Windows.Documents;
using System.Windows.FrameworkElement;
using System.Windows.Media;
using System.Windows.Controls;
using System.Windows;

using Nemerle.Assertions;
using Nemerle.WPF;

using LogGrok.Controls;

namespace LogGrok.LogView
{
    public partial class LogGridViewCell : HighlightedTextBlock
    {
        public this()
        {
            InitializeComponent();
            
            this.DataContextChanged += (_,_) => UpdateValue();
        }
        
        [DependencyProperty(Metadata=PropertyMetadata(null, OnValueGetterChanged))]
        public ValueGetter : VirtualLineViewModel->object
        {
            get; set;
        }
        
        
        private static OnValueGetterChanged(sender : DependencyObject, e : DependencyPropertyChangedEventArgs) : void 
        {
            match(sender)
            {
                | s is LogGridViewCell => 
                    s.UpdateValue();
                | _ => ()
            }
        }
        
        private UpdateValue() : void
        {
            match(DataContext)
            {
                | d is VirtualLineViewModel when ValueGetter != null => Text = ValueGetter(d)?.ToString();
                | _ => ()
            }
        }
    }
}