﻿using Nemerle;
using Nemerle.Assertions;
using Nemerle.Collections;
using Nemerle.Text;
using Nemerle.Utility;

using System;
using System.Collections.Generic;
using System.Linq;

using Microsoft.Practices.Unity;

using LogGrok.IndexedFilter;
using LogGrok.LogView;
using LogGrok.Core;

#pragma warning disable 10003

namespace LogGrok.Search
{

    internal class SearchDocumentFactory
    {
        public this([NotNull] container : IUnityContainer)
        { 
            _container = container;
        }
        
        public Create() : SearchDocument
        {
            def childContainer = CreateChildContainer();
            childContainer.Resolve()
        }
        
        private CreateChildContainer() : IUnityContainer 
        {
            def childContainer = _container.CreateChildContainer();
            
            def FixLifetime[TService]()
            {
                _ = childContainer.RegisterInstance(_container.Resolve.[TService](), ContainerControlledLifetimeManager());
            }
            
            FixLifetime.[IndexedFilter]();
            FixLifetime.[ILogNavigation]();
            FixLifetime.[ILogHighlight]();

            childContainer
        }
        
        private _container : IUnityContainer;
    }
}
